require 'test_helper'

shared_examples_for 'a refreshable resource' do
  describe "#refresh" do
    it "can refresh to a new object", vcr: true do
      raise "Set @klass in a before block to use refreshing tests" unless @klass
      raise "Set @id in a before block to use refreshing tests" unless @id
      object = @klass.find(@id)
      assert object 
      new_object = object.refresh
      assert_equal object.id, new_object.id
      assert object.inspect != new_object.inspect
    end
  end
  describe "#refresh!" do
    it "can refresh its values", vcr: true do
      raise "Set @klass in a before block to use refreshing tests" unless @klass
      raise "Set @id in a before block to use refreshing tests" unless @id
      object = @klass.find(@id)
      assert object 
      object_dump = object.inspect
      object.refresh!
      assert object_dump != object.inspect
    end
  end
  describe "#find" do
    it "should accept a block", vcr: true do
      raise "Set @klass in a before block to use refreshing tests" unless @klass
      raise "Set @id in a before block to use refreshing tests" unless @id

      class SpecialSpecificTestError < StandardError; end
      assert_raises(SpecialSpecificTestError) do
        @klass.find(@id) do
          raise SpecialSpecificTestError
        end
      end
    end
  end
end