require 'test_helper'

describe "Datarobot::AiApi" do
  before do
    @key="testing"
  end

  it "is sane" do
    api = Datarobot::AiApi
    # if we make it to here, nothing has exploded
    assert(api)
  end

  it "can be configured" do
    key = @key
    api = Datarobot::AiApi.configure!(api_key: key)
    # if we make it to here, nothincg has exploded
    assert(api.api_key == key)
  end

  describe "#ping" do
    it "works when authorized", vcr: true do
      key = @key
      api = Datarobot::AiApi.configure!(api_key: key)
      response_data = api.ping
      assert_equal response_data, {"response" => "pong"}
    end

    it "returns unauthorized when not authorized", vcr: true do
      api = Datarobot::AiApi.configure!(api_key: '')
      assert_raises Datarobot::AiApi::UnauthorizedError do 
        api.ping
      end
    end
  end

  describe "#ping_me" do
    it "works when authorized", vcr: true do
      key = @key
      api = Datarobot::AiApi.configure!(api_key: key)
      response_data = api.ping
      assert_equal response_data, {"response" => "pong"}
    end

    it "returns unauthorized when not authorized", vcr: true do
      api = Datarobot::AiApi.configure!(api_key: '')
      assert_raises Datarobot::AiApi::UnauthorizedError do 
        api.ping_me
      end
    end
  end
end